//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <list>
#include <string>
#include <algorithm>
#include <conio.h> //  getch()
#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;
std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main(int argc, char* argv[])
{
  list<int> coll;
  //      6  1   1  6
  for (int i=1; i<=6; ++i) {
    coll.push_front(i);
    coll.push_back(i);
  }
  //    
  cout << ToRus(" :\n");
  copy (coll.begin(), coll.end(), // 
    ostream_iterator<int>(cout," ")); // 

  cout << endl;

  //      3
  // -    
  list<int>::iterator end =  remove (coll.begin(), coll.end(),   // 
                                      3);  // 

    //    
  cout << ToRus(" :\n");
  copy (coll.begin(), end, // 
    ostream_iterator<int>(cout," ")); // 

  cout << endl;

  //   "" 
  cout << ToRus("  : ")
    << distance(end,coll.end()) << endl;

  //  "" 
  coll.erase(end,coll.end());

  //     
  cout << ToRus("  :\n");
  copy (coll.begin(), coll.end(), // 
    ostream_iterator<int>(cout," ")); // 

  cout << endl;

  getch();
  return 0;
}
//---------------------------------------------------------------------------
